#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <portbits.h>
#include "global.h"
#include "lcd.h"

unsigned char * const mem=(unsigned char * const)DDRAM;
//unsigned char cgram[16][8];
unsigned char viewstart;

void lcd_init(void)
{	cli();
	wdt_disable();

	MCUCR=(1<<SRE)|(0<<SRW10);					// Enable XMEM

	OCR1A=10;
	OCR1B=RELOAD/2;
	ICR1=RELOAD-1;
	TCCR1A=(1<<COM1A1)|(1<<COM1B1)|(1<<COM1B0)|(1<<WGM11);	// Enable PWM/Framerate (Kontrast)
	TCCR1B=(1<<WGM12)|(1<<WGM13)|1;
	TIMSK|=(1<<TOIE1);

	sei();
	lcd_clear();
	wdt_enable(WDTO_250MS);
	ENABLE_VLCD=1;	
}



void lcd_clear(void)
{	unsigned short i;
	for (i=0; i<(65536-DDRAM); i++)
		mem[i]=0;
}




//void lcd_setstartx(unsigned char pos)
//{
//	if (pos>88)
//		pos=88;
//	pos*=2;
//	viewstart=pos;
//}
